#!/bin/bash

# Category : Miscellaneous
# Description : LibrePortal - WebUI Dashboard (c/t/u/s/r/i):

installLibrePortal()
{
    local config_variables="$1"

    if [[ "$libreportal" == *[cCtTuUsSrRiI]* ]]; then
        dockerConfigSetupToContainer silent libreportal;
        local app_name=$CFG_LIBREPORTAL_APP_NAME
		initializeAppVariables $app_name;
    fi

    if [[ "$libreportal" == *[cC]* ]]; then
        editAppConfig $app_name;
    fi

    if [[ "$libreportal" == *[uU]* ]]; then
        dockerUninstallApp $app_name;
    fi

    if [[ "$libreportal" == *[sS]* ]]; then
        dockerComposeDown $app_name;
    fi

    if [[ "$libreportal" == *[rR]* ]]; then
        dockerComposeRestart $app_name;
    fi

    if [[ "$libreportal" == *[iI]* ]]; then
        isHeader "Install $app_name"

		((menu_number++))
        echo "---- $menu_number. Copying LibrePortal source and building the image."
        echo ""

        installLibrePortalImageWebUI;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up install folder and config file for $app_name."
        echo ""

        dockerConfigSetupToContainer "loud" "$app_name" "install" "$config_variables";
        isSuccessful "Install folders and Config files have been setup for $app_name."

		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up the $app_name docker-compose.yml file."
        echo ""

        dockerComposeSetupFile $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Updating file permissions before starting."
        echo ""

		fixPermissionsBeforeStart $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Randomizing WebUI login credentials."
        echo ""

        local webui_logins_file="$configs_dir/webui/webui_logins"
        scanFileForRandomPasswordKeysUsers "$webui_logins_file"
        sourceScanFiles "libreportal_configs"
        isSuccessful "WebUI login credentials have been set."

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running the docker-compose.yml to install and start $app_name"
        echo ""

		dockerComposeUpdateAndStartApp $app_name install;

        ((menu_number++))
        echo ""
        echo "---- $menu_number. Running Application specific updates (if required)"
        echo ""

        appUpdateSpecifics $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running Headscale setup (if required)"
        echo ""

		setupHeadscale $app_name;

		((menu_number++))
		echo ""
        echo "---- $menu_number. Adding $app_name to the Apps Database table."
        echo ""

		databaseInstallApp $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Updating WebUI config file."
        echo ""

        webuiContainerSetup $app_name install;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Generating all WebUI data files."
        echo ""

        webuiLibrePortalUpdate;

        if [[ "$libreportal_bootstrap_install" != "true" ]]; then
            ((menu_number++))
            echo ""
            echo "---- $menu_number. You can find $app_name files at $containers_dir$app_name"
            echo ""
            echo "    You can now navigate to your new service using one of the options below : "
            echo ""

            menuShowFinalMessages $app_name;
            webuiDisplayLogins;
        fi

		menu_number=0
        #sleep 3s
        cd
    fi
    libreportal=n
}
